﻿--[[
****************************************************************************************
AckisRecipeList v0.84
$Date: 2008-04-26 02:51:07 -0400 (Sat, 26 Apr 2008) $
$Rev: 71588 $

Author: Ackis on Illidan US Horde
****************************************************************************************

Please see Wowace.com for more information.

****************************************************************************************
]]

--/dump GetMouseFocus()
local Crayon	= LibStub("LibCrayon-3.0")
local BFAC		= LibStub("LibBabble-Faction-3.0"):GetLookupTable()
local L			= LibStub("AceLocale-3.0"):GetLocale("AckisRecipeList")

AckisRecipeList = LibStub("AceAddon-3.0"):NewAddon("AckisRecipeList", "AceConsole-3.0", "AceEvent-3.0")

ARL = AckisRecipeList

-- Global variables
ARL.RecipeListing = nil
ARL.MissingRecipeListing = nil
ARL.VendorList = nil
ARL.PetList = nil
ARL.MobList = nil
ARL.SkillType = nil
ARL.FoundRecipes = nil
ARL.FilteredRecipes = nil
ARL.NumberOfRecipes = nil
ARL.ResetOkayBlizz = nil
ARL.ResetOkayARL = nil

-- Frame variables
ARL.ScanButton = nil
ARL.Frame = nil

-- Constants
ARL.ARLTitle = "Ackis Recipe List 0.84"
ARL.br = "\n    - "

-- Local variables


-- Command line options for the mod.

ARL.command_options = {
    type = "group",
    args =
	{
		display =
		{
			type = "group",
			name = "Display",
			desc = L["DISPLAY_OPTIONS"],
			order = 1,
			args =
			{
				usegui =
				{
					name	= "Use GUI",
					desc	= L["GUI_TOGGLE"],
					type	= "toggle",
					get		= function() return ARL.db.profile.usegui end,
					set		= function() ARL.db.profile.usegui = not ARL.db.profile.usegui end,
					order	= 1,
				},
				includefiltered =
				{
					name	= "Include Filtered",
					desc	= L["FILTERCOUNT_TOGGLE"],
					type	= "toggle",
					get		= function() return ARL.db.profile.includefiltered end,
					set		= function() ARL.db.profile.includefiltered = not ARL.db.profile.includefiltered end,
					order	= 3,
				},
				closegui =
				{
					name	= "Close GUI",
					desc	= L["CLOSEGUI_TOGGLE"],
					type	= "toggle",
					get		= function() return ARL.db.profile.closeguionskillclose end,
					set		= function() ARL.db.profile.closeguionskillclose = not ARL.db.profile.closeguionskillclose end,
					order	= 4,
				},
			}
		},
        filter =
		{
			type = "group",
			name = "Filter",
			desc = L["FILTER_OPTIONS"],
			order = 2,
			args =
			{
				reputations =
				{
					type = "group",
					name = "Reputations",
					desc = L["REP_OPTIONS"],
					order = 1,
					args =
					{
						Aldor =
						{
							name	= BFAC["The Aldor"],
							desc	= L["ALDOR_TOGGLE"],
							type	= "toggle",
							get		= function() return ARL.db.profile.aldor end,
							set		= function() ARL.db.profile.aldor = not ARL.db.profile.aldor end,
							order	= 1,
						},
						ArgentDawn =
						{
							name	= BFAC["Argent Dawn"],
							desc	= L["ARGENT_TOGGLE"],
							type	= "toggle",
							get		= function() return ARL.db.profile.argentdawn end,
							set		= function() ARL.db.profile.argentdawn = not ARL.db.profile.argentdawn end,
							order	= 5,
						},
						Ashtongue =
						{
							name	= BFAC["Ashtongue Deathsworn"],
							desc	= L["ASHTONGUE_TOGGLE"],
							type	= "toggle",
							get		= function() return ARL.db.profile.ashtonguedeathsworn end,
							set		= function() ARL.db.profile.ashtonguedeathsworn = not ARL.db.profile.ashtonguedeathsworn end,
							order	= 10,
						},
						CenarionCircle =
						{
							name	= BFAC["Cenarion Circle"],
							desc	= L["CENCIR_TOGGLE"],
							type	= "toggle",
							get		= function() return ARL.db.profile.cenarioncircle end,
							set		= function() ARL.db.profile.cenarioncircle = not ARL.db.profile.cenarioncircle end,
							order	= 15,
						},
						CenarionExpidition =
						{
							name	= BFAC["Cenarion Expedition"],
							desc	= L["CENEXP_TOGGLE"],
							type	= "toggle",
							get		= function() return ARL.db.profile.cenarionexpidition end,
							set		= function() ARL.db.profile.cenarionexpidition = not ARL.db.profile.cenarionexpidition end,
							order	= 20,
						},
						Consortium =
						{
							name	= BFAC["The Consortium"],
							desc	= L["CONSORT_TOGGLE"],
							type	= "toggle",
							get		= function() return ARL.db.profile.consortium end,
							set		= function() ARL.db.profile.consortium = not ARL.db.profile.consortium end,
							order	= 25,
						},
						HellfireFactions =
						{
							name	= BFAC["Honor Hold"] .. "\\" .. BFAC["Thrallmar"],
							desc	= L["HELLFIRE_TOGGLE"],
							type	= "toggle",
							get		= function() return ARL.db.profile.hellfirefac end,
							set		= function() ARL.db.profile.hellfirefac = not ARL.db.profile.hellfirefac end,
							order	= 30,
						},
						KoT =
						{
							name	= BFAC["Keepers of Time"],
							desc	= L["KOT_TOGGLE"],
							type	= "toggle",
							get		= function() return ARL.db.profile.kot end,
							set		= function() ARL.db.profile.kot = not ARL.db.profile.kot end,
							order	= 35,
						},
						NagrandFactions =
						{
							name	= BFAC["Kurenai"] .. "\\" .. BFAC["The Mag'har"],
							desc	= L["NAGRAND_TOGGLE"],
							type	= "toggle",
							get		= function() return ARL.db.profile.nagrandfac end,
							set		= function() ARL.db.profile.nagrandfac = not ARL.db.profile.nagrandfac end,
							order	= 40,
						},
						LowerCity =
						{
							name	= BFAC["Lower City"],
							desc	= L["LC_TOGGLE"],
							type	= "toggle",
							get		= function() return ARL.db.profile.lowercity end,
							set		= function() ARL.db.profile.lowercity = not ARL.db.profile.lowercity end,
							order	= 45,
						},
						Scale =
						{
							name	= BFAC["The Scale of the Sands"],
							desc	= L["SCALE_TOGGLE"],
							type	= "toggle",
							get		= function() return ARL.db.profile.scaleofsands end,
							set		= function() ARL.db.profile.scaleofsands = not ARL.db.profile.scaleofsands end,
							order	= 50,
						},
						Scryer =
						{
							name	= BFAC["The Scryers"],
							desc	= L["SCRYER_TOGGLE"],
							type	= "toggle",
							get		= function() return ARL.db.profile.scryer end,
							set		= function() ARL.db.profile.scryer = not ARL.db.profile.scryer end,
							order	= 55,
						},
						Shatar =
						{
							name	= BFAC["The Sha'tar"],
							desc	= L["SHATAR_TOGGLE"],
							type	= "toggle",
							get		= function() return ARL.db.profile.shatar end,
							set		= function() ARL.db.profile.shatar = not ARL.db.profile.shatar end,
							order	= 60,
						},
						SSO =
						{
							name	= BFAC["Shattered Sun Offensive"],
							desc	= L["SSO_TOGGLE"],
							type	= "toggle",
							get		= function() return ARL.db.profile.sso end,
							set		= function() ARL.db.profile.sso = not ARL.db.profile.sso end,
							order	= 65,
						},
						Sporeggar =
						{
							name	= BFAC["Sporeggar"],
							desc	= L["SPORE_TOGGLE"],
							type	= "toggle",
							get		= function() return ARL.db.profile.sporeggar end,
							set		= function() ARL.db.profile.sporeggar = not ARL.db.profile.sporeggar end,
							order	= 70,
						},
						TB =
						{
							name	= BFAC["Thorium Brotherhood"],
							desc	= L["TB_TOGGLE"],
							type	= "toggle",
							get		= function() return ARL.db.profile.thoriumbrotherhood end,
							set		= function() ARL.db.profile.thoriumbrotherhood = not ARL.db.profile.thoriumbrotherhood end,
							order	= 75,
						},
						Timbermaw =
						{
							name	= BFAC["Timbermaw Hold"],
							desc	= L["TIMBERMAW_TOGGLE"],
							type	= "toggle",
							get		= function() return ARL.db.profile.timbermaw end,
							set		= function() ARL.db.profile.timbermaw = not ARL.db.profile.timbermaw end,
							order	= 80,
						},
						Violeteye =
						{
							name	= BFAC["The Violet Eye"],
							desc	= L["VIOLETEYE_TOGGLE"],
							type	= "toggle",
							get		= function() return ARL.db.profile.violeteye end,
							set		= function() ARL.db.profile.violeteye = not ARL.db.profile.violeteye end,
							order	= 85,
						},
						Zandalar =
						{
							name	= BFAC["Zandalar Tribe"],
							desc	= L["ZANDALAR_TOGGLE"],
							type	= "toggle",
							get		= function() return ARL.db.profile.zandalar end,
							set		= function() ARL.db.profile.zandalar = not ARL.db.profile.zandalar end,
							order	= 90,
						},
					}
				},
				factions =
				{
					name	= "Faction",
					desc	= L["FACTION_TOGGLE"],
					type	= "toggle",
					get		= function() return ARL.db.profile.faction end,
					set		= function() ARL.db.profile.faction = not ARL.db.profile.faction end,
					order	= 1,
				},
				PVP =
				{
					name	= "PVP",
					desc	= L["PVP_TOGGLE"],
					type	= "toggle",
					get		= function() return ARL.db.profile.pvp end,
					set		= function() ARL.db.profile.pvp = not ARL.db.profile.pvp end,
					order	= 2,
				},
				classes =
				{
                    name      = "Classes",
                    desc      = L["CLASS_TOGGLE"],
                    type      = "toggle",
                    get       = function() return ARL.db.profile.classes end,
                    set       = function() ARL.db.profile.classes = not ARL.db.profile.classes end,
                    order     = 3,
				},
				specialities =
				{
                    name      = "Specialities",
                    desc      = L["SPECIALITY_TOGGLE"],
                    type      = "toggle",
                    get       = function() return ARL.db.profile.specialities end,
                    set       = function() ARL.db.profile.specialities = not ARL.db.profile.specialities end,
                    order     = 4,
				},
				raid =
				{
                    name      = "Raid",
                    desc      = L["RAID_TOGGLE"],
                    type      = "toggle",
                    get       = function() return ARL.db.profile.raid end,
                    set       = function() ARL.db.profile.raid = not ARL.db.profile.raid end,
                    order     = 5,
				},
				skill =
				{
                    name      = "Skill",
                    desc      = L["SKILL_TOGGLE"],
                    type      = "toggle",
                    get       = function() return ARL.db.profile.skill end,
                    set       = function() ARL.db.profile.skill = not ARL.db.profile.skill end,
                    order     = 6,
				}
			}
		},
		sorting =
		{
			name      = "Sort",
			desc      = L["SORT_OPTIONS"],
			type      = "select",
			values = function() return {L["SORT_Name"], L["SORT_Skill"]} end,
			get       = function() return ARL.db.profile.sorting end,
			set       = function(info,name) ARL:ToggleAllSorting(name) end,
			order     = 3,
		}
	}
}

--[[

	Saved variables functions

]]--

-- Toggles the boolean value of the AllFactions variable in the database.

function ARL:ToggleAllSorting(NewValue)

	if (NewValue == L["SORT_Name"]) then
		ARL.db.profile.sorting = "Name"
	elseif (NewValue == L["SORT_Skill"]) then
		ARL.db.profile.sorting = "Skill"
	end

end

--[[

	Reset functions

]]--

-- Reset all variables

function ARL:ARL_ResetVariables()

	ARL.RecipeListing = nil
	ARL.MissingRecipeListing = nil

	ARL.SkillType = nil
	ARL.FoundRecipes = nil
	ARL.NumberOfRecipes = nil
	ARL.FilteredRecipes = nil

end

-- Initializes the initial recipe array, reseting it completely.

function ARL:InitializeRecipeArray()

	-- Reset namespace to be empty
	ARL.RecipeListing = {}
	ARL.MissingRecipeListing = {}
  
	-- Sets the total number of recipes to 0.
	ARL.NumberOfRecipes = 0

	-- Sets the number of found recipes to 0.
	ARL.FoundRecipes = 0

	-- Sets number of filtered recipes to 0
	ARL.FilteredRecipes = 0

end

--[[

	Initialization functions

]]--

-- Register slash commands and profile defaults

function ARL:OnInitialize()

	self.db = LibStub("AceDB-3.0"):New("AckisRecipeListDB", defaults, "Default")

    LibStub("AceConfig-3.0"):RegisterOptionsTable("AckisRecipeList", ARL.command_options)
    self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("AckisRecipeList", "AckisRecipeList")
    self:RegisterChatCommand("ackisrecipelist", "ChatCommand")
    self:RegisterChatCommand("arl", "ChatCommand")

	-- Set default options, which are to include everything in the scan
	self.db:RegisterDefaults(
		{ profile =
			{
			-- Filter Options
		    faction = true,
			classes = false,
			pvp = true,
			specialities = false,
			raid = true,
			skill = true,

			-- Sorting Options
			sorting = "Skill",

			-- Display Options
			usegui = true,
			includefiltered = false,
			closeguionskillclose = false,

			-- Reputation Options
			aldor = true,
			scryer = true,
			argentdawn = true,
			ashtonguedeathsworn = true,
			cenarioncircle = true,
			cenarionexpidition = true,
			consortium = true,
			hellfirefac = true,
			kot = true,
			nagrandfac = true,
			lowercity = true,
			scaleofsands = true,
			shatar = true,
			sso = true,
			sporeggar = true,
			thoriumbrotherhood = true,
			timbermaw = true,
			violeteye = true,
			zandalar = true,
			}
		}
	)

end

-- Register events and create the scan button on enable

function ARL:OnEnable()

	-- Make addon respond to the tradeskill and crafting windows being shown
	self:RegisterEvent("TRADE_SKILL_SHOW")
	self:RegisterEvent("CRAFT_SHOW")

	-- Addon responds to tradeskill and crafting windows being closed.
	self:RegisterEvent("CRAFT_CLOSE")
	self:RegisterEvent("TRADE_SKILL_CLOSE")

	-- Add an option so that ARL will work with Manufac
	if Manufac then
		Manufac.options.args.ARLScan = {
			type = 'execute',
			name = L["Scan Skills"],
			desc = L["Scan Skills Long"],
			func = function() ARL:AckisRecipeList_Command() end,
			order = 550,
		}
	end

	--Create the button now for later use
	ARL:CreateScanButton()

end

-- Hides the frame if the mod gets disabled

function ARL:OnDisable()

	ARL:ARL_ResetVariables()
	ARL.VendorList = nil
	ARL.PetList = nil
	ARL.MobList = nil

	if ARL.Frame then
		ARL.Frame:Hide()
	end

	-- Remove the option from Manufac
	if Manufac then
		Manufac.options.args.ARLScan = nil
	end

end

-- Watch for the trade skill window to be shown, add all specific trade skills to an array, then scan the trade skill window for all recipes.

function ARL:TRADE_SKILL_SHOW()

	ARL.SkillType = "Trade"
	ARL.ResetOkayBlizz = false
	if (not Skillet) then
		ARL:ShowScanButton()
	end

end

-- Clean up tables from memory when trade skill window is closed

function ARL:TRADE_SKILL_CLOSE()

	ARL.ResetOkayBlizz = true
	if (ARL.ResetOkayBlizz and ARL.ResetOkayARL) then
		ARL:ARL_ResetVariables()
	end
	if (ARL.db.profile.closeguionskillclose) then
		if (ARL.Frame) then
			ARL:CloseWindow()
		end
	end
	if (not Skillet) then
		ARL.ScanButton:Hide()
	end

end

-- Watch for the craft skill window to be shown, add all specific trade skills to an array, then scan the craft skill window for all recipes.

function ARL:CRAFT_SHOW()

	ARL.SkillType = "Craft"
	ARL.ResetOkayBlizz = false
	if (not Skillet) then
		ARL:ShowScanButton()
	end

end

-- Clean up tables from memory when craft window is closed

function ARL:CRAFT_CLOSE()

	ARL.ResetOkayBlizz = true
	if (ARL.ResetOkayBlizz and ARL.ResetOkayARL) then
		ARL:ARL_ResetVariables()
	end
	if (ARL.db.profile.closeguionskillclose) then
		if (ARL.Frame) then
			ARL:CloseWindow()
		end
	end
	if (not Skillet) then
		ARL.ScanButton:Hide()
	end

end

-- Slash command handler

function ARL:ChatCommand(input)
    if not input or input:trim() == "" then
        InterfaceOptionsFrame_OpenToFrame(self.optionsFrame)
    else
        LibStub("AceConfigCmd-3.0").HandleCommand(ARL, "arl", "AckisRecipeList", input)
    end
end


--[[

	Tradeskill functions

]]--

-- Adds a specifc recipe to the recipe list array.  Also provides information regarding recipe level, if there is any trade skill recipe speciality, how to aquire the recipe, and if the recipe is known or not.

function ARL:addTradeSkill(RecipeName, RecipeLevel, RecipeAquire, RecipeSpeciality, VendorInfo, RecipeKnown)

	-- Creates a table in the ARL.RecipeListing table storing all information about a recipe
	ARL.RecipeListing[RecipeName] = {}
	ARL.RecipeListing[RecipeName]["Level"] = RecipeLevel
	ARL.RecipeListing[RecipeName]["Acquire"] = RecipeAquire

	if (RecipeSpeciality == nil) then

		ARL.RecipeListing[RecipeName]["Speciality"] = {}

	else

		ARL.RecipeListing[RecipeName]["Speciality"] = RecipeSpeciality

	end

	if (VendorInfo == nil) then

		ARL.RecipeListing[RecipeName]["VendorInfo"] = {}

	else

		ARL.RecipeListing[RecipeName]["VendorInfo"] = VendorInfo

	end

	if (RecipeKnown == nil) then

		ARL.RecipeListing[RecipeName]["Known"] = false

	else

		ARL.RecipeListing[RecipeName]["Known"] = RecipeKnown

	end

	-- Increment the total number of recipes added to the list
	ARL.NumberOfRecipes = ARL.NumberOfRecipes + 1

end

-- Same as previous function but uses spell ID to get recipe name

function ARL:addTradeSkillSpell(RecipeName, RecipeLevel, RecipeAquire, RecipeSpeciality, VendorInfo, RecipeKnown)

	if (GetSpellInfo(RecipeName) ~= nil) then

		ARL:addTradeSkill(GetSpellInfo(RecipeName), RecipeLevel, RecipeAquire, RecipeSpeciality, VendorInfo, RecipeKnown)

	else

		ARL:addTradeSkill(tostring(RecipeName), RecipeLevel, RecipeAquire, RecipeSpeciality, VendorInfo, RecipeKnown)
		self:Print("Spell ID: " .. RecipeName .. " is not in your local cache.")

	end

end

-- Same as previous but combines spell rank for beast training

function ARL:addTradeSkillBeast(RecipeName, RecipeLevel, RecipeAquire, RecipeSpeciality, VendorInfo, RecipeKnown)

	local Jimo,Megadopolous = GetSpellInfo(RecipeName)

	if (Jimo ~= nil) then

		local TempHunterSkill = Jimo .. " (" .. Megadopolous .. ")"
		ARL:addTradeSkill(TempHunterSkill, RecipeLevel, RecipeAquire, RecipeSpeciality, VendorInfo, RecipeKnown)

	else

		ARL:addTradeSkill(tostring(RecipeName), RecipeLevel, RecipeAquire, RecipeSpeciality, VendorInfo, RecipeKnown)
		self:Print("Spell ID: " .. RecipeName .. " is not in your local cache.")

	end

end

-- Adds vendor information to the vendor list array.

function ARL:addVendorList(VendorID, VendorName, VendorFaction, VendorLoc, VendorCoords)

	ARL.VendorList[VendorID] = {}
	ARL.VendorList[VendorID]["Name"] = VendorName
	ARL.VendorList[VendorID]["Faction"] = VendorFaction
	ARL.VendorList[VendorID]["Location"] = VendorLoc
	ARL.VendorList[VendorID]["Coords"] = VendorCoords

end

-- Adds pet information to the pet list array

function ARL:addPetList(PetID, PetName, PetLocation, PetLevelMin, PetLevelMax, isElite, isRare)

	ARL.PetList[PetID] = {}
	ARL.PetList[PetID]["Name"] = PetName
	ARL.PetList[PetID]["Location"] = PetLocation
	ARL.PetList[PetID]["MinLvl"] = PetLevelMin
	ARL.PetList[PetID]["MaxLvl"] = PetLevelMax
	ARL.PetList[PetID]["Elite"] = isElite
	ARL.PetList[PetID]["Rare"] = isRare

end

-- Modifies recipe array if a recipe is found, setting the Known flag as true.

function ARL:foundTradeSkill(RecipeName)

	ARL.RecipeListing[RecipeName]["Known"] = true

	-- Increase found count
	ARL.FoundRecipes = ARL.FoundRecipes + 1

end

-- Checks to see if a recipe is known or not.  If the recipe is not in the database, output it to chat.

function ARL:CheckRecipe(RecipeName)

	if (ARL.RecipeListing[RecipeName]) then

		-- Update array that recipe was found
		ARL:foundTradeSkill(RecipeName)
	
	else

		-- Notify users in chat that skill is missing from the database.
		ARL:printMissingSkill(RecipeName)

	end

end

-- Check to see if recipe should be displayed or not

function ARL:CheckDisplayRecipe(RecipeName, CurrentProfessionLevel, CurrentProfession, CurrentSpeciality)

	-- Display all skill levels
	if (ARL.MissingRecipeListing[RecipeName]["Level"] > CurrentProfessionLevel) then

		if (not ARL.db.profile.skill) then

			ARL.FilteredRecipes = ARL.FilteredRecipes + 1
			return false

		end

	end

	local classcheck = false
	local classoccur = false
	local displaycheck = true

	if (ARL.MissingRecipeListing[RecipeName]["Speciality"] ~= nil) then

		for i, CurrentCheck in pairs(ARL.MissingRecipeListing[RecipeName]["Speciality"]) do

			-- Display hard to obtain raid recipes
			if (not ARL.db.profile.raid) then
				if (CurrentCheck == L["Raid"]) then
					displaycheck = false
				end
			end

			-- Display all faction recipes
			if (not ARL.db.profile.faction) then
				local playerFaction = UnitFactionGroup("player")
				-- Make sure the check is Horde or Alliance
				if (CurrentCheck == BFAC["Horde"]) or (CurrentCheck == BFAC["Alliance"]) then
					-- If the current check isn't the same as the player faction, don't display it
					if (CurrentCheck ~= playerFaction) then
						displaycheck = false
					end
				end
			end

			-- NEED TO FIX LOGIC HERE
			-- Display all class type recipes
			if (not ARL.db.profile.classes) then
				local _, playerClass = UnitClass("player")
				-- Make sure it's a class
				if (CurrentCheck == "WARLOCK") or 
				(CurrentCheck == "WARRIOR") or 
				(CurrentCheck == "HUNTER") or 
				(CurrentCheck == "MAGE") or 
				(CurrentCheck == "PRIEST") or 
				(CurrentCheck == "DRUID") or 
				(CurrentCheck == "PALADIN") or 
				(CurrentCheck == "SHAMAN") or 
				(CurrentCheck == "ROGUE") then
				-- Set that a class check has occured in the case of multiple classes.
				classoccur = true
					if (CurrentCheck == playerClass) then
						classcheck = true
					end
				end

			end

			-- Display all Scryer recipes
			if (not AckisRecipeList.db.profile.scryer) then
				if (CurrentCheck == BFAC["The Scryers"]) then
					displaycheck = false
				end

			end
			-- Display all Aldor recipes
			if (not AckisRecipeList.db.profile.aldor) then
				if (CurrentCheck == BFAC["The Aldor"]) then
					displaycheck = false
				end
			end
			-- Display all Argent Dawn recipes
			if (not ARL.db.profile.argentdawn) then
				if (CurrentCheck == BFAC["Argent Dawn"]) then
					displaycheck = false
				end
			end
			-- Display all Ashtongue Deathsworn recipes
			if (not ARL.db.profile.ashtonguedeathsworn) then
				if (CurrentCheck == BFAC["Ashtongue Deathsworn"]) then
					displaycheck = false
				end
			end
			-- Display all Cenarion Circle recipes
			if (not ARL.db.profile.cenarioncircle) then
				if (CurrentCheck == BFAC["Cenarion Circle"]) then
					displaycheck = false
				end
			end
			-- Display all Cenarion Expidition recipes
			if (not ARL.db.profile.cenarionexpidition) then
				if (CurrentCheck == BFAC["Cenarion Expidition"]) then
					displaycheck = false
				end
			end
			-- Display all Consortium recipes
			if (not ARL.db.profile.consortium) then
				if (CurrentCheck == BFAC["The Consortium"]) then
					displaycheck = false
				end
			end
			-- Display all Honor Hold/Thrallmar recipes
			if (not ARL.db.profile.hellfirefac) then
				if (CurrentCheck == BFAC["Honor Hold"]) or (CurrentCheck == BFAC["Thrallmar"]) then
					displaycheck = false
				end
			end
			-- Display all Keepers of Time recipes
			if (not ARL.db.profile.kot) then
				if (CurrentCheck == BFAC["Keepers of Time"]) then
					displaycheck = false
				end
			end
			-- Display all Kureni/Mag'har recipes
			if (not ARL.db.profile.nagrandfac) then
				if (CurrentCheck == BFAC["Kurenei"]) or (CurrentCheck == BFAC["The Mag'har"]) then
					displaycheck = false
				end
			end
			-- Display all Lower City recipes
			if (not ARL.db.profile.lowercity) then
				if (CurrentCheck == BFAC["Lower City"]) then
					displaycheck = false
				end
			end
			-- Display all Scale of the Sands recipes
			if (not ARL.db.profile.scaleofsands) then
				if (CurrentCheck == BFAC["The Scale of the Sands"]) then
					displaycheck = false
				end
			end
			-- Display all Sha'tar recipes
			if (not ARL.db.profile.shatar) then
				if (CurrentCheck == BFAC["The Sha'tar"]) then
					displaycheck = false
				end
			end
			-- Display all Scale of the Sands recipes
			if (not ARL.db.profile.sso) then
				if (CurrentCheck == BFAC["Shattered Sun Offensive"]) then
					displaycheck = false
				end
			end
			-- Display all Sporeggar recipes
			if (not ARL.db.profile.sporeggar) then
				if (CurrentCheck == BFAC["Sporeggar"]) then
					displaycheck = false
				end
			end
			-- Display all Thorium Brotherhood recipes
			if (not ARL.db.profile.thoriumbrotherhood) then
				if (CurrentCheck == BFAC["Thorium Brotherhood"]) then
					displaycheck = false
				end
			end
			-- Display all Timbermaw recipes
			if (not ARL.db.profile.timbermaw) then
				if (CurrentCheck == BFAC["Timbermaw Hold"]) then
					displaycheck = false
				end
			end
			-- Display all Violet Eye recipes
			if (not ARL.db.profile.violeteye) then
				if (CurrentCheck == BFAC["Violet Eye"]) then
					displaycheck = false
				end
			end
			-- Display all Zandalar Tribe recipes
			if (not ARL.db.profile.zandalar) then
				if (CurrentCheck == BFAC["Zandalar Tribe"]) then
					displaycheck = false
				end
			end

			-- Display all specialities (ie: Primal Mooncloth, Spellcloth, etc.)
			if (not ARL.db.profile.specialities) then

				-- Blacksmithing
				if (CurrentProfession == GetSpellInfo(2018)) then

					if (CurrentCheck == GetSpellInfo(9788)) or -- Armorsmith
						(CurrentCheck == GetSpellInfo(17041)) or -- Master Axesmith
						(CurrentCheck == GetSpellInfo(17040)) or -- Master Hammersmith
						(CurrentCheck == GetSpellInfo(17039)) or -- Master Swordsmith
						(CurrentCheck == GetSpellInfo(9787)) then -- Weaponsmith

							if (CurrentCheck ~= CurrentSpeciality) then

								displaycheck = false

							end

					end

				-- Engineering
				elseif (CurrentProfession == GetSpellInfo(4036)) then

					if (CurrentCheck == GetSpellInfo(20219)) or -- Gnomish Engineering
						(CurrentCheck == GetSpellInfo(20222)) then -- Goblin Engineering

							if (CurrentCheck ~= CurrentSpeciality) then

								displaycheck = false

							end

					end

				-- Leatherworking
				elseif (CurrentProfession == GetSpellInfo(2108)) then

					if (CurrentCheck == GetSpellInfo(10657)) or -- Dragonscale
						(CurrentCheck == GetSpellInfo(10659)) or -- Elemental
						(CurrentCheck == GetSpellInfo(10661)) then -- Tribal

							if (CurrentCheck ~= CurrentSpeciality) then

								displaycheck = false

							end

					end

				-- Tailoring
				elseif (CurrentProfession == GetSpellInfo(3908)) then

					if (CurrentCheck == GetSpellInfo(26797)) or -- Spellfire
						(CurrentCheck == GetSpellInfo(26801)) or -- Shadoweave
						(CurrentCheck == GetSpellInfo(26798)) then -- Primal Mooncloth

							if (CurrentCheck ~= CurrentSpeciality) then

								displaycheck = false

							end

					end

				end

			end

		end

	end

	if (displaycheck == true) then

		if (classoccur == true) then

			if (classcheck == false) then

				ARL.FilteredRecipes = ARL.FilteredRecipes + 1

			end

			return classcheck

		else

			return true

		end

	else

		ARL.FilteredRecipes = ARL.FilteredRecipes + 1
		return false

	end

end

-- Scans the first 24 entries in the spellbook to find which profession speciality someone is (assumption is that it will be within the first 24 because of the general tab)

function ARL:GetTradeSpeciality(CurrentProfession)

local index = 1

	while true do

		local spellName = GetSpellName(index, BOOKTYPE_SPELL)

		if (not spellName) or (index == 25) then

			return ""

		end

		-- Alchemy
		if (CurrentProfession == GetSpellInfo(2259)) then

			if (spellName == GetSpellInfo(28674)) or
				(spellName == GetSpellInfo(28678)) or
				(spellName == GetSpellInfo(28676)) then

				return spellName

			end

		-- Blacksmithing
		elseif (CurrentProfession == GetSpellInfo(2018)) then

			if (spellName == GetSpellInfo(9787)) or
				(spellName == GetSpellInfo(9788)) or
				(spellName == GetSpellInfo(17039)) or
				(spellName == GetSpellInfo(17040)) or
				(spellName == GetSpellInfo(17041)) then

				return spellName

			end

		-- Engineering
		elseif (CurrentProfession == GetSpellInfo(4036)) then

		if (spellName == GetSpellInfo(20219)) or (spellName == GetSpellInfo(20222)) then

				return spellName

			end

		-- Leatherworking
		elseif (CurrentProfession == GetSpellInfo(2108)) then

			if (spellName == GetSpellInfo(10657)) or
				(spellName == GetSpellInfo(10659)) or
				(spellName == GetSpellInfo(10661)) then

				return spellName

			end

		-- Tailoring
		elseif (CurrentProfession == GetSpellInfo(3980)) then

			if (spellName == GetSpellInfo(26797)) or -- Spellfire
				(spellName == GetSpellInfo(26798)) or -- Primal Mooncloth
				(spellName == GetSpellInfo(26801)) then -- Shadoweave

				return spellName

			end

		end

		index = index + 1

	end

end

-- Combines all pet information into a single string for output

function ARL:CombinePets(...)
	    local PetInfo = "" 
	    for i=1,select('#',...) do 
	        local CurrentCheck = select(i, ...) 
	        local CurrentPet = "" 
	        if (ARL.PetList[CurrentCheck]["Rare"]) then 
	            CurrentPet = CurrentPet .. L["Rare"] 
	        end 
	        if (ARL.PetList[CurrentCheck]["Elite"]) then 
	            CurrentPet = CurrentPet .. L["Elite"] 
	        end 
	        CurrentPet = CurrentPet .. format("%s (%s - %s):%s%s", ARL.PetList[CurrentCheck]["Name"], ARL.PetList[CurrentCheck]["MinLvl"], ARL.PetList[CurrentCheck]["MaxLvl"], ARL.PetList[CurrentCheck]["Location"], ARL.br) 
	        PetInfo = PetInfo .. CurrentPet 
	    end 
	    return PetInfo 
end

-- Combines all monster information into a single string for output

function ARL:CombineMobs(BoE, MobNames, MobLoc)

	local MobInfo

	if (BoE == true) then
		MobInfo = L["BoE"]
	else
		MobInfo = L["BoP"]
	end

	MobInfo = MobInfo .. MobNames .. " (" .. MobLoc .. ")"

	return MobInfo

end

-- Combines all quest information into a single string for output

function ARL:CombineQuests(QuestName, QuestFaction, QuestLoc)

	local QuestInfo = format("%s%s (%s)", L["QuestReward"],QuestName,QuestLoc)
	local playerFaction = UnitFactionGroup("player")

	if (QuestFaction == BFAC["Alliance"]) then
		if (AckisRecipeList.db.profile.faction or playerFaction == BFAC["Alliance"]) then
			QuestInfo = Crayon:Cyan(QuestInfo)
		end
	elseif (QuestFaction == BFAC["Horde"]) then
		if (AckisRecipeList.db.profile.faction or playerFaction == BFAC["Horde"]) then
			QuestInfo = Crayon:Red(QuestInfo)
		end
	elseif (QuestFaction == BFAC["Neutral"]) then
		QuestInfo = Crayon:Gold(QuestInfo)
	end

	return QuestInfo
end

-- Combines Vendor name, location, faction into a single string.  A list of Vendor IDs is provided, along with if the recipe is limited supply.

function ARL:CombineVendors(...)

	local VendorInfo
	local NumArgs = select("#", ...)

	if (select(NumArgs, ...) == false) then
		VendorInfo = L["Vendor"]
	else
		VendorInfo = L["LimitedSupply"]
	end

	local playerFaction = UnitFactionGroup("player")

	for i=1,(NumArgs-1),1 do 
		local CurrentCheck = select(i, ...) 
		local CurrentVendor = format("%s%s - %s: %s", ARL.br, ARL.VendorList[CurrentCheck]["Name"], ARL.VendorList[CurrentCheck]["Location"], ARL.VendorList[CurrentCheck]["Coords"])
		if (ARL.VendorList[CurrentCheck]["Faction"] == BFAC["Alliance"]) then
			if (AckisRecipeList.db.profile.faction or playerFaction == BFAC["Alliance"]) then
				VendorInfo = VendorInfo .. Crayon:Cyan(CurrentVendor)
			end
		elseif (ARL.VendorList[CurrentCheck]["Faction"] == BFAC["Horde"]) then
			if (AckisRecipeList.db.profile.faction or playerFaction == BFAC["Horde"]) then
				VendorInfo = VendorInfo .. Crayon:Red(CurrentVendor)
			end
		elseif (ARL.VendorList[CurrentCheck]["Faction"] == BFAC["Neutral"]) then
			VendorInfo = VendorInfo .. Crayon:Gold(CurrentVendor)
		else
			VendorInfo = VendorInfo .. CurrentVendor
		end
	end

	return VendorInfo

end

-- Combines repuation level and faction name into a single string.

function ARL:ARL_AddReputation1(RepLevel, Faction)

	return format("%s: %s", RepLevel, Faction)

end

-- Combines reputation level and faction name of two factions into a single string.

function ARL:ARL_AddReputation2(RepLevel, Faction1, Faction2)

	return format("(A) %s: %s%s(H) %s: %s", RepLevel, Faction1, ARL.br, RepLevel, Faction2)

end


--[[

	Sorting Functions

]]--

-- Returns true if a Recipe1 has a lower skill level than Recipe2

local function ARL_SortMissingSkill(Recipe1, Recipe2)

	return ARL.MissingRecipeListing[Recipe1]["Level"] < ARL.MissingRecipeListing[Recipe2]["Level"]

end

-- Returns true if a Recipe1 come before Recipe2 in the alphabet

local function ARL_SortMissingName(Recipe1, Recipe2)

	return Recipe1 < Recipe2

end

-- Sorts the ARL.MissingRecipeListing with the given sorting function

function ARL:SortMissingRecipes(SortFunction)

	local TempRecipeSort = {}

	-- Get all the indexes of the ARL.MissingRecipeListing
	for n in pairs(ARL.MissingRecipeListing) do

		table.insert(TempRecipeSort, n)

	end

	-- Sort the indexes according to the function
	table.sort(TempRecipeSort, SortFunction)

	return TempRecipeSort

end 

--[[
	Recipe Array Functions

]]--

-- Initialize the profession tables depending on which skill window is opened.

local function ARL_InitializeTradeRecipes(CurrentProfession)

	-- Create a table to store all the mobs which drop recipes
	ARL.MobList = {}

	-- Thanks to sylvanaar/xinhuan for the code snippet
	local professiontable =
	{
		[GetSpellInfo(2259)] = ARL.ARL_InitAlchemy,
		[GetSpellInfo(2018)] = ARL.ARL_InitBlackSmith,
		[GetSpellInfo(2550)] = ARL.ARL_InitCooking,
		[GetSpellInfo(4036)] = ARL.ARL_InitEngineering,
		-- Use first aid spell of applying bandages to fix issues with other localizations
		[GetSpellInfo(746)] = ARL.ARL_InitFirstAid,
		-- Hack to get first aid working on frFR since I can't seem to get a proper spell ID :P
		["Premiers soins"] = ARL.ARL_InitFirstAid,
		--[GetSpellInfo(3273)] = ARL.ARL_InitFirstAid,
		[GetSpellInfo(2108)] = ARL.ARL_InitLeatherWorking,
		[GetSpellInfo(2842)] = ARL.ARL_InitRoguePoison,
		[GetSpellInfo(2575)] = ARL.ARL_InitSmelting,
		[GetSpellInfo(3908)] = ARL.ARL_InitTailoring,
		[GetSpellInfo(25229)] = ARL.ARL_InitJewelcrafting,
	}

	local a = professiontable[CurrentProfession]

	if a then
		a(ARL)
	else
		self:Print(L["UnknownTradeSkill"]:format(CurrentProfession))
	end

end

-- Initialize the profession tables depending on which skill window is opened.

local function ARL_InitializeCraftRecipes(CurrentProfession)

	local CurrentProfessionLevel

	if (CurrentProfession == GetSpellInfo(7411)) then
		-- Get the current level of the craft.
		CurrentProfessionLevel = _G["CraftRankFrame"]:GetValue() --Better way to do this?
		-- Create a table to store all the mobs which drop recipes
		ARL.MobList = {}
		-- Add all enchanting recipes to the table
		ARL:ARL_InitEnchanting()

	elseif (CurrentProfession == GetSpellInfo(5149)) then

		-- Player level = profession level for beast training
		CurrentProfessionLevel = UnitLevel("player")
		-- Create a table to store all possible pets
		ARL.PetList = {}
		-- Add all beast training recipes to the table
		ARL:ARL_InitBeastTraining()

	else

		CurrentProfessionLevel = 0
		self:Print(L["UnknownTradeSkill"]:format(CurrentProfession))

	end

	return CurrentProfessionLevel

end

--[[

	Scanning functions

]]--

-- Scans your recipe book for Trade Skill Recipes

function ARL:ScanTradeSkills()

	-- Clear the "Have Materials" check box
	if not Skillet and TradeSkillFrameAvailableFilterCheckButton:GetChecked() then
		TradeSkillFrameAvailableFilterCheckButton:SetChecked(false)
		TradeSkillOnlyShowMakeable(false)
	end

	-- Expand all headers
	for i = GetNumTradeSkills(), 1, -1 do
		local _, tradeType = GetTradeSkillInfo(i)
		if tradeType == "header" then
			ExpandTradeSkillSubClass(i)
		end
	end

	-- Scan through all recipes
	for i = 1, GetNumTradeSkills() do
		local skillName, tradeType = GetTradeSkillInfo(i)
		-- Ignore all trade skill headers
		if (tradeType ~= "header") then
			ARL:CheckRecipe(skillName)
		end
	end

end

-- Scans the ARL.RecipeListing adding all missing recipes to the ARL.MissingRecipeListing

function ARL:ScanMissingRecipes()

	-- Parse the recipe listing table, adding entries to the ARL.MissingRecipeListing table
	if (ARL.RecipeListing ~= nil) then
		local RecipeName = next(ARL.RecipeListing, nil)
			while (RecipeName ~= nil) do
				-- If the recipe is not known then print out the info
				if (ARL.RecipeListing[RecipeName]["Known"] == false) then
					ARL.MissingRecipeListing[RecipeName] = {}
					ARL.MissingRecipeListing[RecipeName]["Level"] = ARL.RecipeListing[RecipeName]["Level"]
					ARL.MissingRecipeListing[RecipeName]["Acquire"] = ARL.RecipeListing[RecipeName]["Acquire"]
					ARL.MissingRecipeListing[RecipeName]["Speciality"] = ARL.RecipeListing[RecipeName]["Speciality"]
				end
				-- Move on to the next entry in the table
				RecipeName = next(ARL.RecipeListing, RecipeName)
			end
	end
end

-- Scans your recipe book for Craft Skill Recipes (enchanting and beast training are handled differently than other trade skills)

function ARL:ScanCraftSkills()

	-- Beast Training
	if CraftIsPetTraining() then
		for i = 1, GetNumCrafts() do
			local skillName, skillRank = GetCraftInfo(i) -- Don't need a lot of this information, what to do with it?
			local FullSkillName = skillName .. " (" .. skillRank .. ")"
			ARL:CheckRecipe(FullSkillName)
		end
	-- Enchanting and any other craft
	else
		-- Clear the "Have Materials" check box
		if not Skillet and CraftFrameAvailableFilterCheckButton:GetChecked() then
			CraftFrameAvailableFilterCheckButton:SetChecked(false)
			CraftOnlyShowMakeable(false)
		end

		-- Scans crafting recipes in opened window, expanding all headers
		for i = GetNumCrafts(), 1, -1 do
			local _, _, craftType = GetCraftInfo(i)
			if craftType == "header" then
				ExpandCraftSkillLine(i)
			end
		end

		-- Scan through all recipes
		for i = 1, GetNumCrafts() do
			local skillName, _, craftType = GetCraftInfo(i)
			-- Ignore all trade skill headers
			if (craftType ~= "header") then
				ARL:CheckRecipe(skillName)
			end
		end
	end
end

-- Main logic for add-on, will call all sub-functions

function ARL:AckisRecipeList_Command()

	local CurrentProfession, CurrentProfessionLevel, CurrentSpeciality, SortedRecipeIndex

	-- Initializes the vendor list
	if (ARL.VendorList == nil) then
		ARL.VendorList = {}
		ARL:ARL_InitVendor()
	end

	ARL:InitializeRecipeArray()

	if (ARL.SkillType == nil) then

		self:Print(L["OpenTradeSkillWindow"])

	-- Trade type skills
	elseif (ARL.SkillType == "Trade") then

		-- Get the name of the current trade skill opened, along with the current level of the skill. 
		CurrentProfession, CurrentProfessionLevel = GetTradeSkillLine()
		CurrentSpeciality = ARL:GetTradeSpeciality(CurrentProfession)
		ARL_InitializeTradeRecipes(CurrentProfession)

		if (CurrentProfession == GetSpellInfo(2842)) then
			-- Player level = profession level for rogue poisons
			CurrentProfessionLevel = UnitLevel("player")
		end

		ARL:ScanTradeSkills()
		ARL:ScanMissingRecipes()

		if (ARL.db.profile.sorting == "Skill") then
			SortedRecipeIndex = ARL:SortMissingRecipes(ARL_SortMissingSkill)
		elseif (ARL.db.profile.sorting == "Name") then
			SortedRecipeIndex = ARL:SortMissingRecipes(ARL_SortMissingName)
		end

		if (AckisRecipeList.db.profile.usegui) then
			ARL:CreateFrame(CurrentProfession, CurrentProfessionLevel, SortedRecipeIndex, CurrentSpeciality)
		else
			ARL:InitiateScan(CurrentProfession, CurrentProfessionLevel, CurrentSpeciality)
			ARL:DisplayRecipeResults(CurrentProfessionLevel, SortedRecipeIndex, CurrentProfession, CurrentSpeciality)
		end

	-- Craft type skills
	elseif (ARL.SkillType == "Craft") then

		-- Get the name of the current craft.
		CurrentProfession = GetCraftName()
		CurrentProfessionLevel = ARL_InitializeCraftRecipes(CurrentProfession)
		CurrentSpeciality = ARL:GetTradeSpeciality(CurrentProfession)
		ARL:ScanCraftSkills()
		ARL:ScanMissingRecipes()

		if (ARL.db.profile.sorting == "Skill") then
			SortedRecipeIndex = ARL:SortMissingRecipes(ARL_SortMissingSkill)
		elseif (ARL.db.profile.sorting == "Name") then
			SortedRecipeIndex = ARL:SortMissingRecipes(ARL_SortMissingName)
		end
		if (AckisRecipeList.db.profile.usegui) then
			ARL:CreateFrame(CurrentProfession, CurrentProfessionLevel, SortedRecipeIndex, CurrentSpeciality)
		else
			ARL:InitiateScan(CurrentProfession, CurrentProfessionLevel, CurrentSpeciality)
			ARL:DisplayRecipeResults(CurrentProfessionLevel, SortedRecipeIndex, CurrentProfession, CurrentSpeciality)
		end

	end

end

